#!/usr/bin/perl -w


my $config="contrib/sln_file.conf";


### Programm ###################################### don't touch recomended ###
use strict;
use vars qw/$ver %m %diz %fbbs %pars %arch @newskip @area %file %count %desc %time %size %list @mon/;

@mon=qw/           /;
#@mon=qw/Jan Feb Mar Ape May Jun Jul Aug Sep Oct Nov Dec/;

$ver='File Lister v0.3 (c) Sln !';

my (%key,$flag);

foreach(@ARGV){ /^list\=(\S+)/ ? (push @{$key{lst}},$1) : ($key{$_}='') }

&conf_main;
uplog("Starting $ver");
&conf_area;
&conf_list if exists $m{list};
#&conf_new  if exists $m{new};
#&conf_del  if exists $m{del};

# find new files
 if(exists $key{new}){
 uplog("Find new files");
 $flag=1;
 &get_new;
 }

# remove desc for non exists files
 if(exists $key{del}){
 uplog("Remove desc for missing files");
 $flag=1;
 &get_del;
 }

# analyse files.bbs
 if(exists $key{bbs}){
 uplog("Analyzing descriptions");
 $flag=1;
 &parse_bbs;
 }

# convert
 if(exists $key{conv}){
 uplog("Convert descriptions");
 $flag=1;
 &conv_bbs;
 }

# filelist
 if(exists $key{lst} and %list){
 foreach(@{$key{lst}}){
 uplog("Generate '$_' list");
 file_list($_);
 }
 $flag=1;
 }


unless($flag){
uplog("Show help message");

print STDERR "
$ver

  Usage: $0 key [key ...]

      keys: new - added new files
            del - remove desc for not exists files
            bbs - parse desc/bbs files
           conv - convert files.bbs -> .desc or desc -> files.bbs
  list=listname - generate filelist where 'listname' is 'id' from 'filelist.conf'

                  exepmle: $0 new del list=full bbs list=new


"
}

uplog("Exit 0\n");
exit 0;

##############################################################################

sub esc{
my @tmp;
 foreach my $m (@_){
  $_=$m;
  s/(\W)/\\$1/g;
  s/\\\*/\.*/g;
  s/\\\?/\.{1}/g;
  push @tmp, $_;
 }
 return '^('.(join '|', @tmp).')$';
}

##############################################################################

sub uplog{
 return unless exists $m{log};
 my $str=shift;
 @_=localtime();
  open(LOG, ">> $m{log}") || die $!;
  print LOG sprintf("%02d/%02d/%02d %02d:%02d:%02d slnfile [$$] $str\n",$_[3],$_[4]+1,substr($_[5],-2),$_[2],$_[1],$_[0]);
  close LOG;
}


##############################################################################

sub uperr{
 uplog($_[0]);
 uplog("Exit 1\n");
 exit 1;
}


##############################################################################

sub conf_main{

open(ARCH,"< $config") || die "$config: $!\n";

while(<ARCH>){

$m{diz}=$1	if /^diz\s+(\S+)/i;
$m{log}=$1	if /^log\s+(\S+)/i;
$m{temp}=$1	if /^temp\s+(.+)/i;
$m{area}=$1	if /^area_file\s+(.+)/i;
$m{list}=$1	if /^list_file\s+(.+)/i;
#$m{new}=$1	if /^list_new\s+(.+)/i;
#$m{del}=$1	if /^list_del\s+(.+)/i;

$diz{nul}=$1	if /^diznull\s+([01])/i;
$diz{del}=$1	if /^dizdsymb\s+(.*)/i;
$diz{rep}=$1	if /^dizrsymb\s+(.*)/i;
$diz{rec}=$1	if /^dizrec\s+([dwk]{2}|0)/i;

$fbbs{file}=$1	if /^filebbs\s+(\S+)/i;
$fbbs{cpos}=$1	if /^countpos\s+(\d+)/i;
$fbbs{cmsk}=$1	if /^countmask\s+(..|0)/i;
$fbbs{cnum}=$1	if /^countnum\s+(\d+)/i;
$fbbs{frst}=$1	if /^commentf\s+(\d+)/i;
$fbbs{next}=$1	if /^commentn\s+(.+)/i;
$fbbs{ext}=$1	if /^descext\s+(.+)/i;
$fbbs{path}=$1	if /^descpath\s+(.+)/i;

$pars{count}=$1	if /^bbscount\s+([01])/i;
$pars{cnul}=$1	if /^bbscountnull\s+([01])/i;
$pars{rold}=$1	if /^bbsremold\s+(\d+.\d+.\d+|\d+)/i;
$pars{sort}=$1	if /^bbssort\s+(0|[1234]r?)/i;
$pars{dupe}=$1	if /^bbsdupe\s+([01])/i;

push @newskip,$1	if /^newskip\s+(.+)/i;

# id, ext and def archiv cmd's
 if(/^archid\s+([+-]?\d+)\s+([0-9a-f]+)\s+(.+)$/i){
 my ($p,$c)=($1,$3);
 push @{$arch{id}}, [$p,(join '', map {chr hex} $2=~/(.{2})/g),$c];
 }
 push @{$arch{ext}}, [$1,$2] if /^archext\s+(\S+)\s+(.+)$/i;
 $arch{def}=$1 if /^archdef\s+(.+)$/i;

}

close(ARCH);

# calc old date
if($pars{rold}){
    if($pars{rold}=~/^\d+$/)
      {$pars{rold}=time()-$pars{rold}*86400 }
 elsif($pars{rold}=~/^(\d+).(\d+).(\d+)$/)
      {use Time::Local; $pars{rold}=timelocal(0,0,0,$1,$2-1,$3) || die "$!\n" }
}


# user to program hack
$fbbs{cpos}-- if $fbbs{cpos} != 0;
$fbbs{frst}-- if $fbbs{frst} != 0;
$fbbs{next}-- if $fbbs{next} != 0 and $fbbs{next}=~/^\d+$/;

$fbbs{cmsk}=($fbbs{cmsk} ? [split //,$fbbs{cmsk}] : ['','']);
}

##############################################################################

sub conf_area{

uplog("Parse '$m{area}'");

undef @area;
my $i;

open(AREA, "< $m{area}") || uperr("$m{area}: $!");
my @tmp=<AREA>;
close(AREA);

for($i=0;$i<@tmp;$i++){
 if($tmp[$i]=~/^path\s+(.+)/i){
  my ($path,$desc,$level,$list)=($1);
   foreach(@tmp[$i+1..$#tmp]){
    last	if /^path\s/i;
    $desc=$1	if /^desc\s+(.+)/i;
    $level=$1	if /^level\s+(\d+)/i;
    $list=$1	if /^list\s+(\d+)/i;
   }
    if(-d $path){ push @area, [$path,($desc || 'Auto added area'),($level || '0'),($list || '0')] }
            else{ uplog("$path: $!") }
 }
}

uplog("Defined ".scalar(@area)." area(s)");
}

##############################################################################

sub conf_list{

uplog("Parse '$m{list}'");

undef %list;
my ($id,$i);

open(LIST, "< $m{list}") || uperr("$m{list}: $!");
my @tmp=<LIST>;
close(LIST);

for($i=0;$i<@tmp;$i++){
 if($tmp[$i]=~/^id\s+(.+)/i){
  $id=$1;

   # default
    $list{$id}{comment}=32;
    $list{$id}{sort}=0;
    $list{$id}{file}='filelist.txt';
    $list{$id}{what}=0;
    $list{$id}{size}='b';
    $list{$id}{recbbs}=0;
    $list{$id}{rectpl}=0;
    $list{$id}{period}=0;
    $list{$id}{count}=0;
    undef %{$list{$id}{level}};
    undef %{$list{$id}{new}};

   foreach(@tmp[$i+1..$#tmp]){
    last if /^id\s/i;
    $list{$id}{tpl}=$1		if /^tpl\s+(.+)/i;
    $list{$id}{comment}=$1	if /^comment\s+(\d+)/i;
    $list{$id}{sort}=$1		if /^sort\s+([1234]r?)/i;
    $list{$id}{file}=$1		if /^file\s+(.+)/i;
    $list{$id}{what}=$1		if /^what\s+([012])/i;
    $list{$id}{size}=$1		if /^size\s+(a|b|k|m|g)/i;
    $list{$id}{recbbs}=$1	if /^recbbs\s+([dwk]{2})/i;
    $list{$id}{rectpl}=$1	if /^rectpl\s+([dwk]{2})/i;
    $list{$id}{new}{$1}=$2	if /^new\s+(\d+)\s+(.+)/i;
    $list{$id}{period}=$1	if /^period\s+(\d+)/i;
    $list{$id}{count}=$1	if /^count\s+(.\d+.|0)/i;
    $list{$id}{level}{$1}=undef	if /^level\s+(.+)/i;
   }
    $list{$id}{count}=[split /(\d+)/, $list{$id}{count}] if $list{$id}{count};
 }
}

%list ? uplog("Defined ".(join ", ", map {"'$_'"} keys %list)) : uperr("Lists not defined");
}

##############################################################################

sub conf_new{

uplog("Parse '$m{new}'");

}

##############################################################################

sub conf_del{

uplog("Parse '$m{del}'");

}

##############################################################################

sub fbbs_var{

my ($i,$path,$type)=(0,@_);

(%file,%count,%desc,%time,%size)=();

if($type == 0){
 return unless -f "$path/$fbbs{file}";
 open(FB, "< $path/$fbbs{file}") || uperr("$path/$fbbs{file}: $!");
 my @fb=<FB>;
 close(FB);

 foreach(@fb){
 s/[\r\n]$//;

  if($fbbs{next}=~/^\d+$/){
       if(/^(\S+)/){
	$i++;
       # file
        $file{$i}=$1;
       # stat
        ($size{$i},$time{$i})=(stat("$path/$1"))[7,9];
       # counter
	if($fbbs{cpos}){ $count{$i}=$1 if substr($_,$fbbs{cpos})=~/^\Q$fbbs{cmsk}[0]\E(\d+)\Q$fbbs{cmsk}[1]\E/ }
                   else{ $count{$i}=$1 if               $_=~/^\S+\s+\Q$fbbs{cmsk}[0]\E(\d+)\Q$fbbs{cmsk}[1]\E/ }
       # comment
        if($fbbs{frst}){ $desc{$i}=substr($_,$fbbs{frst}) }
                   else{ (exists $count{$i}) ? (/^\S+\s+\Q$fbbs{cmsk}[0]$count{$i}$fbbs{cmsk}[1]\E\s+(.+)$/) : (/^\S+\s+(.+)$/); $desc{$i}=$1 }
       # chop/def counter
	$count{$i}+=0;
       }else{
       # other comment
	$desc{$i}.="\n".substr($_,$fbbs{next}) if $fbbs{next} > 0;
	$desc{$i}.="\n$1" if $fbbs{next} == 0 and /^\s+(.*)$/;
       }
  }else{
       if(/^(\S+)/ and !/^\Q$fbbs{next}/){
	$i++;
       # file
        $file{$i}=$1;
       # stat
        ($size{$i},$time{$i})=(stat("$path/$1"))[7,9];
       # counter
	if($fbbs{cpos}){ $count{$i}=$1 if substr($_,$fbbs{cpos})=~/^\Q$fbbs{cmsk}[0]\E(\d+)\Q$fbbs{cmsk}[1]\E/ }
                   else{ $count{$i}=$1 if               $_=~/^\S+\s+\Q$fbbs{cmsk}[0]\E(\d+)\Q$fbbs{cmsk}[1]\E/ }
       # comment
        if($fbbs{frst}){ $desc{$i}=substr($_,$fbbs{frst}) }
                   else{ (exists $count{$i}) ? (/^\S+\s+\Q$fbbs{cmsk}[0]$count{$i}$fbbs{cmsk}[1]\E\s+(.+)$/) : (/^\S+\s+(.+)$/); $desc{$i}=$1 }
       # chop/def counter
	$count{$i}+=0;
       }else{
       # other comment
	$desc{$i}.="\n$1" if /^\s*\Q$fbbs{next}\E(.*)$/;
       }
  }
 }
}

if($type == 1){
	opendir(DESC,"$path/$fbbs{path}") || (uplog("$path/$fbbs{path}: $!"), return);
	my @tmp=grep{-f "$path/$fbbs{path}/$_" and /^.+\Q$fbbs{ext}\E$/i} readdir(DESC);
	closedir(DESC);
       foreach(@tmp){
	/^(.+)\Q$fbbs{ext}\E$/i or next;
       # file
	$file{$i}=$1;
       # stat
	($size{$i},$time{$i})=(stat("$path/$1"))[7,9];
       # count (hack)
	$count{$i}=0;
       # comment
	open(DESC,"< $path/$fbbs{path}/$_") || uperr("$path/$fbbs{path}/$_: $!");
	 while(<DESC>){ s/[\r\n]$//; $desc{$i}.="$_\n" }
	 chomp($desc{$i});
	close(DESC);
	$i++;
       }
}

}

##############################################################################

sub var_fbbs{

my ($path,$type)=@_;

if($type == 0){
uplog("Update $path/$fbbs{file}");
 my $bbs;
 foreach my $id (sort {$a<=>$b} keys %file){
  $_=(($fbbs{cpos} and $pars{count}) ? substr($file{$id}." "x($fbbs{cpos}-length($file{$id})),0,$fbbs{cpos}) : "$file{$id} ");
  $_.=sprintf("$fbbs{cmsk}[0]%0$fbbs{cnum}d$fbbs{cmsk}[1] ", $count{$id}) if $pars{count};
  $_=($fbbs{frst} ? substr($_." "x($fbbs{frst}-length($_)),0,$fbbs{frst}) : $_);
  @_=split /[\r\n]/, $desc{$id};
  $_.=(shift)."\n";
  foreach my $next (@_){ $_.=($fbbs{next} ? ($fbbs{next}=~/^\d+$/ ? " "x$fbbs{next} : " $fbbs{next}") : " ")."$next\n" }
  $bbs.=$_;
 }
#  open(BBS,"> $path/$fbbs{file}") || uperr("$path/$fbbs{file}: $!");
  print $bbs;
#  close(BBS);
}

if($type == 1){
 uplog("Update descs in $path/$fbbs{path}");
 unless(-d "$path/$fbbs{path}"){ mkdir("$path/$fbbs{path}",0766) || uperr("$path/$fbbs{path}: $!") }
 foreach my $id (keys %file){
  open(DSC,"> $path/$fbbs{path}/$file{$id}$fbbs{ext}") || uperr("$path/$fbbs{path}/$file{$id}$fbbs{ext}: $!");
  print DSC $desc{$id};
  close(DSC);
 }
}

}

##############################################################################

sub get_new{

my $reg=esc(@newskip);

foreach my $id (@area){
fbbs_var(@{$id}[0,3]);

my %tmp=reverse %file;

# get new files
opendir(AREA, $id->[0]) || uperr("$id->[0]: $!");
my @tmp = grep{(-f "$id->[0]/$_" and not /$reg/i) and not exists $tmp{$_}} readdir(AREA);
closedir(AREA);

 if(@tmp){
  @_=sort{$b<=>$a} keys %file;
  my $i=$_[0];
   foreach my $file (@tmp){
   $i++;
   $file{$i}=$file;
   $count{$i}=0;
   ($size{$i},$time{$i})=(stat("$id->[0]/$file"))[7,9];
   $desc{$i}=file_desc($id->[0],$file);
   }
  var_fbbs(@{$id}[0,3]);
 }

}

}

##############################################################################

sub get_del{

foreach my $id (@area){
fbbs_var(@{$id}[0,3]);

my (%tmp1,@rm,$flag);
my %tmp2=reverse %file;
my $i=0;

opendir(AREA, $id->[0]) || uperr("$id->[0]: $!");
%tmp1 = map {$_,undef} grep{-f "$id->[0]/$_"} readdir(AREA);
closedir(AREA);

 foreach(keys %tmp2){
  unless(exists $tmp1{$_}){
  push @rm, "$id->[0]/$fbbs{path}/$_$fbbs{ext}" if $id->[3] == 1;
  uplog("Delete desc for '$_'");
  delete $file{$tmp2{$_}};
  $flag=1;
  }
 }

# unlink
foreach(@rm){ unlink($_) || uperr("$_: $!") }

var_fbbs(@{$id}[0,3]) if $flag;
}

}

##############################################################################

sub file_desc{

my ($path,$file,$desc,$f,$cmd)=@_;

# by ident
open(F,"< $path/$file") || uperr("$path/$file: $!");
binmode(F);
 foreach $f (@{$arch{id}}){
 seek F,abs($f->[0]),($f->[0] < 0 ? 2 : 0);
 read F,$_,length($f->[1]);
 $cmd=$f->[2], last if $_ eq $f->[1];
 }
close(F);


# by extension
unless(defined $cmd){
 foreach $f (@{$arch{ext}}){
 my $reg=esc($f->[0]);
 $cmd=$f->[1], last if $file=~/$reg/i;
 }
}


# by default
$cmd=$arch{def} unless defined $cmd;


uplog("Extract '$m{diz}' from '$file' success") unless system getcmd($cmd,$file,$path);

unless(-f "$m{temp}/$m{diz}"){
 uplog("Extract '$m{diz}' from '$file' success (default)") unless system getcmd($arch{def},$file,$path);
}

open(DSC,"< $m{temp}/$m{diz}") || (uplog("Open '$m{diz}' from '$file' failure"), return("$m{temp}/$m{diz}: $!"));
 while(<DSC>){ s/[\r\n]$//; $desc.="$_\n" }
 chomp($desc);
close(DSC);

unlink("$m{temp}/$m{diz}") || uperr("$m{temp}/$m{diz}: $!");

my $tmp='';
foreach(split /[\r\n]/, $desc){
 # null line
 next if $diz{nul} and /^\s*$/;
 $tmp.="$_\n";
}
 chomp($tmp);
 # encode
 $tmp=join '', recode($diz{rec},$tmp);
 # remove symbols
 $tmp=~s/\Q$diz{del}\E//g if $diz{del};
 # replace symbols
 $tmp=~s/\Q$diz{rep}\E/ /g if $diz{rep};

 $tmp;
}

sub getcmd{
my ($cmd,$file,$path)=@_;

# os hack
if($^O=~/(win32|os2)/i){
 $cmd=~s/%a/$file/g;
 $cmd=~s/%p/$path/g;
 $cmd=~s/%t/$m{temp}/g;
 $cmd=~s/%f/$m{diz}/g;
 $cmd=~s/\//\\/g;
}else{
 $cmd=~s/%a/\Q$file/g;
 $cmd=~s/%p/\Q$path/g;
 $cmd=~s/%t/\Q$m{temp}/g;
 $cmd=~s/%f/\Q$m{diz}/g;
}
 $cmd;
}

##############################################################################

sub recode{
my $code=shift;
my ($in,$out,$k,$w,$d);

return @_ if !$code or $code=~/^(.).*\1$/;

$k='\xE1\xE2\xF7\xE7\xE4\xE5\xF6\xFA\xE9\xEA\xEB\xEC\xED\xEE\xEF\xF0\xF2\xF3\xF4\xF5\xE6\xE8\xE3\xFE\xFB\xFD\xFF\xF9\xF8\xFC\xE0\xF1\xC1\xC2\xD7\xC7\xC4\xC5\xD6\xDA\xC9\xCA\xCB\xCC\xCD\xCE\xCF\xD0\x90\x91\x92\x81\x87\xB2\xB4\xA7\xA6\xB5\xA1\xA8\xAE\xAD\xAC\x83\x84\x89\x88\x86\x80\x8A\xAF\xB0\xAB\xA5\xBB\xB8\xB1\xA0\xBE\xB9\xBA\xB6\xB7\xAA\xA9\xA2\xA4\xBD\xBC\x85\x82\x8D\x8C\x8E\x8F\x8B\xD2\xD3\xD4\xD5\xC6\xC8\xC3\xDE\xDB\xDD\xDF\xD9\xD8\xDC\xC0\xD1\xB3\xA3\x99\x98\x93\x9B\x9F\x97\x9C\x95\x9E\x96\xBF\x9D\x94\x9A';
$w='\xC0\xC1\xC2\xC3\xC4\xC5\xC6\xC7\xC8\xC9\xCA\xCB\xCC\xCD\xCE\xCF\xD0\xD1\xD2\xD3\xD4\xD5\xD6\xD7\xD8\xD9\xDA\xDB\xDC\xDD\xDE\xDF\xE0\xE1\xE2\xE3\xE4\xE5\xE6\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF\x2D\x2D\x2D\xA6\x2B\xA6\xA6\xAC\xAC\xA6\xA6\xAC\x2D\x2D\x2D\xAC\x4C\x2B\x54\x2B\x2D\x2B\xA6\xA6\x4C\xE3\xA6\x54\xA6\x3D\x2B\xA6\xA6\x54\x54\x4C\x4C\x2D\xE3\x2B\x2B\x2D\x2D\x2D\x2D\xA6\xA6\x2D\xF0\xF1\xF2\xF3\xF4\xF5\xF6\xF7\xF8\xF9\xFA\xFB\xFC\xFD\xFE\xFF\xA8\xB8\xAA\xBA\xAF\xBF\xA1\xA2\xB0\x95\xB7\x76\xB9\xA4\xA6\xA0';
$d='\x80\x81\x82\x83\x84\x85\x86\x87\x88\x89\x8A\x8B\x8C\x8D\x8E\x8F\x90\x91\x92\x93\x94\x95\x96\x97\x98\x99\x9A\x9B\x9C\x9D\x9E\x9F\xA0\xA1\xA2\xA3\xA4\xA5\xA6\xA7\xA8\xA9\xAA\xAB\xAC\xAD\xAE\xAF\xB0\xB1\xB2\xB3\xB4\xB5\xB6\xB7\xB8\xB9\xBA\xBB\xBC\xBD\xBE\xBF\xC0\xC1\xC2\xC3\xC4\xC5\xC6\xC7\xC8\xC9\xCA\xCB\xCC\xCD\xCE\xCF\xD0\xD1\xD2\xD3\xD4\xD5\xD6\xD7\xD8\xD9\xDA\xDB\xDC\xDD\xDE\xDF\xE0\xE1\xE2\xE3\xE4\xE5\xE6\xE7\xE8\xE9\xEA\xEB\xEC\xED\xEE\xEF\xF0\xF1\xF2\xF3\xF4\xF5\xF6\xF7\xF8\xF9\xFA\xFB\xFC\xFD\xFE\xFF';

$in=$k if $code=~/^k/i;
$in=$w if $code=~/^w/i;
$in=$d if $code=~/^d/i;
$out=$k if $code=~/k$/i;
$out=$w if $code=~/w$/i;
$out=$d if $code=~/d$/i;

map {eval "tr/$in/$out/"} @_;

@_;
}

##############################################################################

sub parse_bbs{

foreach my $id (@area){
fbbs_var(@{$id}[0,3]);

my @rm;

 # remove dupes
 if($pars{dupe} and $id->[3] == 0){
  %file=reverse %file; %file=reverse %file;
 }

 # remove old
 if($pars{rold}){
 foreach(keys %file){
  if(defined $time{$_} and $pars{rold} > $time{$_}){
   push @rm, "$id->[0]/$fbbs{path}/$file{$_}$fbbs{ext}" if $id->[3] == 1; # for files.bbs not need
   push @rm, "$id->[0]/$file{$_}";
   uplog("Remove old '$file{$_}'");
   delete $file{$_};
  }
 }
 }

 # null counts
 if($pars{cnul} and $id->[3] == 0){
  foreach(keys %file){ $count{$_}=0 }
 }

 # sort
 sort_bbs($pars{sort}) if $id->[3] == 0 and $pars{sort};

 # unlink
 foreach(@rm){ unlink($_) || uperr("$_: $!") }

var_fbbs(@{$id}[0,3]);
}

}

##############################################################################

sub sort_bbs{
local $^W=0;

my $str=shift;
my (%f,%t,%s,%c,%d,@tmp,$i);

 if($str=~/1/) { foreach my $key (sort {lc($file{$a}) cmp lc($file{$b}) || $a<=>$b} keys %file){ push @tmp, $key } }
 if($str=~/4/) { foreach my $key (sort {$count{$a}    <=> $count{$b}    || $a<=>$b} keys %file){ push @tmp, $key } }
 if($str=~/3/) { foreach my $key (sort {$size{$a}     <=> $size{$b}     || $a<=>$b} keys %file){ push @tmp, $key } }
 if($str=~/2/) { foreach my $key (sort {$time{$a}     <=> $time{$b}     || $a<=>$b} keys %file){ push @tmp, $key } }
 if($str=~/r/i){ @tmp=reverse @tmp }

return unless @tmp;

 foreach(@tmp){
  $i++;
  $f{$i}=$file{$_};
  $s{$i}=$size{$_};
  $t{$i}=$time{$_};
  $c{$i}=$count{$_};
  $d{$i}=$desc{$_};
 }
  %file=%f;
  %size=%s;
  %time=%t;
  %count=%c;
  %desc=%d;
}

##############################################################################

sub conv_bbs{

 foreach my $id (@area){
 fbbs_var(@{$id}[0,3]);
 var_fbbs($id->[0],($id->[3] ? 0 : 1));
 }

}

##############################################################################

sub file_list{
my $id=shift;

uperr("Template '$id' in '$m{list}' not found") unless exists $list{$id};

my %tpl=get_tpl($list{$id}{tpl});
my $timestart=time();
my (@date,@body,@sarea,@ssize,@snum,@sdel,$form,$stotsize,$stotnum,$stotdel);

# body
foreach my $aid (@area){
next if %{$list{$id}{level}} and not exists $list{$id}{level}{$aid->[2]};

 fbbs_var(@{$aid}[0,3]);
 sort_bbs($list{$id}{sort}) if exists $list{$id}{sort};

 my ($totsize,$del,$num)=(0,0,0);
 my $flag;

foreach my $fid (sort {$a<=>$b} keys %file){

 # only this period
 next if $time{$fid} and $list{$id}{period} and time()-$time{$fid} > $list{$id}{period}*86400;

 # for header/footer
 (defined $size{$fid}) ? ($totsize+=$size{$fid}) : ($del++);
 $num++;

 # only missing file
 next if $list{$id}{what} == 2 and defined $size{$fid};
 # only exist file
 next if $list{$id}{what} == 1 and not defined $size{$fid};

 # counter
 my $count='';
 $count=sprintf("$list{$id}{count}[0]%0$list{$id}{count}[1]d$list{$id}{count}[2]", substr($count{$fid},-$list{$id}{count}[1])) if $list{$id}{count};

 # new prefix
 my $new='';
 if(%{$list{$id}{new}} and $time{$fid}){
 foreach(sort {$a<=>$b} keys %{$list{$id}{new}}){ $new=$list{$id}{new}{$_}, last if $time{$fid} > time()-$_*86400 }
 }

 # day, month, year
 @date=get_time($time{$fid});

 # comment
 my @comment=split /[\r\n]/, $desc{$fid};
 my $comment=(shift @comment || '');

 if(exists $tpl{bb}){
  $form=$tpl{bb};
  $form=get_form($form,lc($file{$fid}),                       'file');
  $form=get_form($form,uc($file{$fid}),                       'FILE');
  $form=get_form($form,$file{$fid},                           'File');
  $form=get_form($form,get_size($list{$id}{size},$size{$fid}),'size');
  $form=get_form($form,$date[0],                              'day');
  $form=get_form($form,$date[1],                              'MON');
  $form=get_form($form,$date[2],                              'mon');
  $form=get_form($form,$date[3],                              'YEAR');
  $form=get_form($form,$date[4],                              'year');
  $form=get_form($form,$new,                                  'new');
  $form=get_form($form,$count,                                'count');
  $form=get_form($form,$comment,                              'comment');
  $flag.=$form;
  foreach(@comment){ $flag.=(" "x$list{$id}{comment})."$_\n" }
 }

}


 if(defined $flag){
  push @sarea,$aid->[1];
  push @ssize,$totsize;
  push @snum,$num;
  push @sdel, $del;
  $stotsize+=$totsize;
  $stotnum+=$num;
  $stotdel+=$del;

  # body header
  if(exists $tpl{bh}){
  $form=$tpl{bh};
  $form=get_form($form,$aid->[1],                          'area');
  $form=get_form($form,$aid->[2],                          'level');
  $form=get_form($form,get_size($list{$id}{size},$totsize),'size');
  $form=get_form($form,$num,                               'num');
  $form=get_form($form,$del,                               'del');
  push @body, recode($list{$id}{rectpl},$form);
  }

  # body body
  push @body, recode($list{$id}{recbbs},$flag);

  # body footer
  if(exists $tpl{bf}){
  $form=$tpl{bf};
  $form=get_form($form,$aid->[1],                          'area');
  $form=get_form($form,$aid->[2],                          'level');
  $form=get_form($form,get_size($list{$id}{size},$totsize),'size');
  $form=get_form($form,$num,                               'num');
  $form=get_form($form,$del,                               'del');
  push @body, recode($list{$id}{rectpl},$form);
  }
 }


}





if(@body){

# top
 if(exists $tpl{tb}){
 @date=get_time(time);
 $form=$tpl{tb};
 $form=get_form($form,$date[0],'day');
 $form=get_form($form,$date[1],'MON');
 $form=get_form($form,$date[2],'mon');
 $form=get_form($form,$date[3],'YEAR');
 $form=get_form($form,$date[4],'year');
 unshift @body, recode($list{$id}{rectpl},$form);
 }


# summary head
 if(exists $tpl{sh}){
 $form=$tpl{sh};
 $form=get_form($form,scalar(@sarea),                      'pos');
 $form=get_form($form,get_size($list{$id}{size},$stotsize),'size');
 $form=get_form($form,$stotnum,                            'num');
 $form=get_form($form,$stotdel,                            'del');
 push @body, recode($list{$id}{rectpl},$form);
 }


# summary body
 if(exists $tpl{sb}){
 for my $i(0..$#sarea){
 $form=$tpl{sb};
 $form=get_form($form,$i+1,                                 'pos');
 $form=get_form($form,$sarea[$i],                           'area');
 $form=get_form($form,get_size($list{$id}{size},$ssize[$i]),'size');
 $form=get_form($form,$snum[$i],                            'num');
 $form=get_form($form,$sdel[$i],                            'del');
 push @body, recode($list{$id}{rectpl},$form);
 }
 }


# summary footer
 if(exists $tpl{sf}){
 $form=$tpl{sf};
 $form=get_form($form,scalar(@sarea),                      'pos');
 $form=get_form($form,get_size($list{$id}{size},$stotsize),'size');
 $form=get_form($form,$stotnum,                            'num');
 $form=get_form($form,$stotdel,                            'del');
 push @body, recode($list{$id}{rectpl},$form);
 }


# footer body
 if(defined $tpl{fb}){
 @date=get_time(time);
 $form=$tpl{fb};
 $form=get_form($form,$ver,             'ver');
 $form=get_form($form,time()-$timestart,'gentime');
 $form=get_form($form,$date[0],         'day');
 $form=get_form($form,$date[1],         'MON');
 $form=get_form($form,$date[2],         'mon');
 $form=get_form($form,$date[3],         'YEAR');
 $form=get_form($form,$date[4],         'year');
 push @body, recode($list{$id}{rectpl},$form);
 }

}

 unless(@body){
 uplog("Skip write empty filelist");
 return;
 }

 open(LIST,"> $list{$id}{file}") || uplog("$list{$id}{file}: $!");
 print LIST @body;
 close(LIST);
}

##############################################################################

sub get_size{
 my ($type,$size)=@_;
 return "- " unless defined $size;
 return $size." " if $type eq "b";
 return sprintf("%.1f",int($size/1024*10)/10)."k" if $type eq "k";
 return sprintf("%.1f",int($size/1024**2*10)/10)."m" if $type eq "m";
 return sprintf("%.1f",int($size/1024**3*10)/10)."g" if $type eq "g";
 return sprintf("%.1f",int($size/1024**3*10)/10)."g" if $size >= 1_000_000_000;
 return sprintf("%.1f",int($size/1024**2*10)/10)."m" if $size >= 1_000_000;
 return sprintf("%.1f",int($size/1024*10)/10)   ."k" if $size >= 1_000;
 return sprintf("%.1f",$size)."b";
}

##############################################################################

sub get_time{
 my @date;
 defined $_[0] ? (@_=(localtime($_[0]))[3..5]) : (undef @_);
  push @date, (defined $_[0] ? sprintf("%02d", $_[0]) : "--");
  push @date, (defined $_[1] ? $mon[$_[1]] : "---");
  push @date, (defined $_[1] ? sprintf("%02d", $_[1]+1) : "--");
  push @date, (defined $_[2] ? $_[2]+1900 : "----");
  push @date, (defined $_[2] ? substr($_[2], -2) : "--");
 @date; 
}

##############################################################################

sub get_tpl{
 open(TPL, "< $_[0]") || uperr("$_[0]: $!");
 my @tpl=<TPL>;
 close(TPL);

 my $tpl=sub{
             my ($i,$end,@tpl,@ret)=@_;
             for $i ($i+1..$#tpl){
             $tpl[$i]=~s/[\r\n]//;
             return($i+1, join '',@ret) if $tpl[$i] eq $end;
             push @ret,"$tpl[$i]\n";
             }
             uperr("Close '$end' string not found");
            };

my (%tpl,$i);
 for($i=0;$i<@tpl;$i++){
  ($i,$tpl{tb})=&$tpl($i,$1,@tpl) if $tpl[$i]=~/^(\$TOP_BODY)$/;
  ($i,$tpl{bh})=&$tpl($i,$1,@tpl) if $tpl[$i]=~/^(\$BODY_HEAD)$/;
  ($i,$tpl{bb})=&$tpl($i,$1,@tpl) if $tpl[$i]=~/^(\$BODY_BODY)$/;
  ($i,$tpl{bf})=&$tpl($i,$1,@tpl) if $tpl[$i]=~/^(\$BODY_FOOT)$/;
  ($i,$tpl{sh})=&$tpl($i,$1,@tpl) if $tpl[$i]=~/^(\$SUMM_HEAD)$/;
  ($i,$tpl{sb})=&$tpl($i,$1,@tpl) if $tpl[$i]=~/^(\$SUMM_BODY)$/;
  ($i,$tpl{sf})=&$tpl($i,$1,@tpl) if $tpl[$i]=~/^(\$SUMM_FOOT)$/;
  ($i,$tpl{fb})=&$tpl($i,$1,@tpl) if $tpl[$i]=~/^(\$FOOT_BODY)$/;
 }

%tpl;
}

##############################################################################

sub get_form{
my ($str,$val,$ref)=@_;

my $form=sub{
              if(lc($_[2]) eq 'l'){ return (substr $_[0],0,$_[1]).$_[3]x($_[1]-length $_[0]) }
              if(lc($_[2]) eq 'r'){ return $_[3]x($_[1]-length $_[0]).(substr $_[0],0,$_[1]) }
              if(lc($_[2]) eq 'c'){ $_=int(($_[1]-length $_[0])/2); return $_[3]x$_.(substr $_[0],0,$_[1]).$_[3]x($_[1]-$_-length $_[0]) }
            };

 $str=~s/\$$ref\[(\d+),([clr]),(.)\]/&$form($val,$1,$2,$3)/ge;
 $str=~s/\$$ref/$val/g;
 $str;
}

##############################################################################
